#include <windows.h>
#include <string.h>
#include "wndid.h"

typedef BOOL (*pSetLayeredWindowAttributes)(
	HWND hwnd,COLORREF crKey,BYTE bAlpha,DWORD dwFlags);
pSetLayeredWindowAttributes _SetLayeredWindowAttributes;
#define LWA_ALPHA	0x00000002

const LPCSTR szWindowClass = "IEEEEN_CLASS";
const LPCSTR szWindowTitle = "` Ver1.00";

int alpha;
char IEtitle[1024];

const char* getIniFileName(void) {
	static unsigned char iniFileName[1024]={0};
	if(iniFileName[0]==0) {
		int pos=-1,i;
		GetModuleFileName(NULL,(LPTSTR)iniFileName,
			sizeof(iniFileName));
		for(i=0;iniFileName[i]!=0;i++) {
			if(iniFileName[i]>=0x80)i++;
			if(iniFileName[i]=='\\')pos=i+1;
		}
		if(pos<0 || pos>i)pos=i;
		iniFileName[pos]=0;
		lstrcat(iniFileName,"ieeeen.ini");
	}
	return (const char*)iniFileName;
}

void WndResizeByClient(HWND hWnd,int x,int y) {
	RECT size;
	RECT wndsize;
	GetClientRect(hWnd,&size);
	GetWindowRect(hWnd,&wndsize);
	wndsize.right=wndsize.right-wndsize.left;
	wndsize.bottom=wndsize.bottom-wndsize.top;
	SetWindowPos(hWnd,NULL,0,0,x+wndsize.right-size.right,y+wndsize.bottom-size.bottom,SWP_NOMOVE | SWP_NOREPOSITION | SWP_NOZORDER);
}

HWND SearchWindow(const char* title) {
	char nowTitle[1000];
	HWND hFirstWnd;
	HWND hNowWnd;
	hFirstWnd=FindWindow(NULL,NULL);
	hNowWnd=GetWindow(hFirstWnd,GW_HWNDFIRST);
	while(hNowWnd!=NULL) {
		if(IsWindowVisible(hNowWnd) &&
				!(GetWindowLong(hNowWnd,GWL_EXSTYLE) & WS_EX_LAYERED)) {
			GetWindowText(hNowWnd,nowTitle,sizeof(nowTitle));
			if(strstr(nowTitle,title)!=NULL) {
				return hNowWnd;
			}
		}
		hNowWnd=GetWindow(hNowWnd,GW_HWNDNEXT);
	}
	return NULL;
}

BOOL CALLBACK ConfigDlgProc(HWND hDlg,UINT message,
                         WPARAM wParam,LPARAM lParam) {
	static int nowAlpha;
	char strBuffer[100];
	SCROLLINFO si;

	switch(message) {
		case WM_INITDIALOG:
			nowAlpha=alpha;
			si.cbSize=sizeof(si);
			si.fMask=SIF_PAGE | SIF_POS | SIF_RANGE;
			si.nMin=0;
			si.nMax=255;
			si.nPage=1;
			si.nPos=nowAlpha;
			SendMessage(GetDlgItem(hDlg,IDC_SCROLL_ALPHA),
				SBM_SETRANGE,0,100);
			SendMessage(GetDlgItem(hDlg,IDC_SCROLL_ALPHA),
				SBM_SETPOS,nowAlpha,TRUE);
			SetScrollInfo(GetDlgItem(hDlg,IDC_SCROLL_ALPHA),SB_CTL,
				&si,TRUE);
			wsprintf(strBuffer,"%4d",nowAlpha);
			SetWindowText(GetDlgItem(hDlg,IDC_LABEL_ALPHA),strBuffer);
			SetWindowText(GetDlgItem(hDlg,IDC_EDIT_WNDTITLE),IEtitle);
			return TRUE;
			break;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDOK:
					alpha=nowAlpha;
					GetWindowText(GetDlgItem(hDlg,IDC_EDIT_WNDTITLE),
						IEtitle,sizeof(IEtitle));
					EndDialog(hDlg,TRUE);
					return TRUE;
					break;
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
					return TRUE;
					break;
			}
			break;
		case WM_HSCROLL:
			if(lParam==(LPARAM)GetDlgItem(hDlg,IDC_SCROLL_ALPHA)) {
				switch(LOWORD(wParam)) {
					case SB_LINELEFT:
						nowAlpha--;
						if(nowAlpha<0)nowAlpha=0;
						break;
					case SB_LINERIGHT:
						nowAlpha++;
						if(nowAlpha>255)nowAlpha=255;
						break;
					case SB_PAGELEFT:
						nowAlpha-=10;
						if(nowAlpha<0)nowAlpha=0;
						break;
					case SB_PAGERIGHT:
						nowAlpha+=10;
						if(nowAlpha>255)nowAlpha=255;
						break;
					case SB_THUMBTRACK:
						nowAlpha=HIWORD(wParam);
						break;
					case SB_THUMBPOSITION:
						nowAlpha=HIWORD(wParam);
						break;
				}
				SendMessage(GetDlgItem(hDlg,IDC_SCROLL_ALPHA),
					SBM_SETPOS,nowAlpha,TRUE);
				wsprintf(strBuffer,"%4d",nowAlpha);
				SetWindowText(GetDlgItem(hDlg,IDC_LABEL_ALPHA),strBuffer);
			}
			break;
	}
	return FALSE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message,
                         WPARAM wParam, LPARAM lParam)
{
	static HFONT hIeeeenFont;
	static HFONT hConfigFont;
	HINSTANCE hInst;
	HWND hTargetWnd;
	const char* iniFile;

	switch (message) {
		case WM_CREATE:
			hInst=GetModuleHandle(NULL);
			hIeeeenFont=CreateFont(
				50,0,0,0,FW_NORMAL,0,0,0,SHIFTJIS_CHARSET,
				OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
				DRAFT_QUALITY,DEFAULT_PITCH,"lr ");
			hConfigFont=CreateFont(
				15,0,0,0,FW_NORMAL,0,0,0,SHIFTJIS_CHARSET,
				OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
				DRAFT_QUALITY,DEFAULT_PITCH,"lr SVbN");
			SendMessage(
				CreateWindowEx(0,"BUTTON","`",
					WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON,
					10,10,350,70,hWnd,
					(HMENU)IDC_BUTTON_IEEEEN,hInst,NULL),
				WM_SETFONT,(WPARAM)hIeeeenFont,FALSE);
			SendMessage(
				CreateWindowEx(0,"BUTTON","ݒ",
					WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
					10,90,350,25,hWnd,
					(HMENU)IDC_BUTTON_CONFIG,hInst,NULL),
				WM_SETFONT,(WPARAM)hConfigFont,FALSE);
			WndResizeByClient(hWnd,370,125);

			iniFile=getIniFileName();
			GetPrivateProfileString("config","ietitle",
				"Internet Explorer",IEtitle,sizeof(IEtitle),iniFile);
			alpha=GetPrivateProfileInt("config","alpha",32,iniFile);
			if(alpha<0)alpha=0;
			if(alpha>255)alpha=255;
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_BUTTON_IEEEEN:
					while(hTargetWnd=SearchWindow(IEtitle)) {
						if(hTargetWnd) {
							SetWindowLong(hTargetWnd,GWL_EXSTYLE,
								GetWindowLong(hTargetWnd,GWL_EXSTYLE) | WS_EX_LAYERED);
							_SetLayeredWindowAttributes(hTargetWnd,0,alpha,LWA_ALPHA);
						}
					}
					break;
				case IDC_BUTTON_CONFIG:
					hInst=GetModuleHandle(NULL);
					if(DialogBox(hInst,"CONFIGDLG",hWnd,(DLGPROC)ConfigDlgProc)) {
						char strBuffer[100];
						iniFile=getIniFileName();
						WritePrivateProfileString("config","ietitle",
							IEtitle,iniFile);
						wsprintf(strBuffer,"%d",alpha);
						WritePrivateProfileString("config","alpha",
							strBuffer,iniFile);
					}
					break;
				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_DESTROY:
			DeleteObject(hIeeeenFont);
			DeleteObject(hConfigFont);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}

	return 0;
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	WNDCLASSEX wcex;
	HWND hWnd;
	HBRUSH h3DFaceBrush;
	HMODULE hdll;
	HICON hIcon,hIconSm;

	hdll=LoadLibrary("user32.dll");
	if(hdll==NULL) {
		MessageBox(0,"user32.dll̓ǂݍ݂Ɏs܂B",
			"G[",MB_OK | MB_ICONSTOP | MB_TOPMOST);
		return 1;
	}
	else {
		_SetLayeredWindowAttributes=(pSetLayeredWindowAttributes)
			GetProcAddress(hdll,"SetLayeredWindowAttributes");
		if(_SetLayeredWindowAttributes==NULL) {
			FreeLibrary(hdll);
			MessageBox(0,"̊ɂ͑ΉĂ܂B\r\n"
				"Windows2000ȍ~Windows OSgpĂB",
				"G[",MB_OK | MB_ICONSTOP | MB_TOPMOST);
			return 1;
		}
	}

	h3DFaceBrush=CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	hIcon=LoadImage(hInstance,"MAINICON",IMAGE_ICON,32,32,LR_SHARED);
	hIconSm=LoadImage(hInstance,"MAINICON",IMAGE_ICON,16,16,LR_SHARED);

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style          = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc    = (WNDPROC)WndProc;
	wcex.cbClsExtra     = 0;
	wcex.cbWndExtra     = 0;
	wcex.hInstance      = hInstance;
	wcex.hIcon          = hIcon;
	wcex.hCursor        = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName   = NULL;
	wcex.lpszClassName  = szWindowClass;
	wcex.hbrBackground  = h3DFaceBrush;
	wcex.hIconSm        = hIconSm;

	RegisterClassEx(&wcex);

	hWnd = CreateWindow(szWindowClass,
		szWindowTitle, WS_OVERLAPPEDWINDOW &
			~(WS_MAXIMIZEBOX | WS_THICKFRAME),
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
		NULL, NULL, hInstance, NULL);

	if (!hWnd) 
		return FALSE;

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	DeleteObject(h3DFaceBrush);

	return msg.wParam;
}

